/*
  Copyright 2009 CNRS-LAAS

  Author: Oussama Kanoun
*/

#ifndef HPP_LOS_COM_BOUNDING_TASK_H
#define HPP_LOS_COM_BOUNDING_TASK_H

#include "hpp/localstepper/task/task.hh"
class ChppLosRobotLink;
class ChppGikStandingRobot;
/**
A task to maintain the center of mass of a CjrlHumanoidDynamicRobot belonging to a ChppLosCentipede inside the corresponding support polygon.
\ingroup tasks
 */
class ChppLosComBoundingTask: public ChppLosTask
{
    public:

        /**
        \brief Constructor
         */
        ChppLosComBoundingTask ( ChppLosCentipede& inCentipede, ChppLosRobotLink& inRobotLink );
        /**
        \brief Set the area of translation brake inside the support polygon
         */
        void setMargins ( double inDi, double inDs, double inXi );
        /**
        \brief Inherited. Return false;
         */
        bool isEqualityTask() const {return false;};
        /**
        \brief Inherited.
         */
        void computeDifferentialSystem();
        /**
        \brief Inherited.
         */
        const vectorN& currentValue();

    private:
        ChppLosRobotLink* attRobotLink;
        ChppGikStandingRobot* attStandingRobot;
        double attComXi,attComDi,attComDs;


        matrixNxP jacCom;
        matrixNxP jacP;
        matrixNxP jacO;
        matrixNxP jacF,jac;
        vectorN jacVec;
        double attLeftAnkleHeight,attRightAnkleHeight;
};

#endif
