/*
  Copyright 2009 CNRS-LAAS

  Author: Oussama Kanoun
*/
#ifndef HPP_LOS_FEET_AREA_TASK_H
#define HPP_LOS_FEET_AREA_TASK_H

#include "hpp/localstepper/task/task.hh"
class ChppLosLink;
/**
A task to maintain the configuration of a left footprint within limits defined with respect to right footprint.
\ingroup tasks
 */
class ChppLosFeetAreaTask: public ChppLosTask
{
    public:
        /**
        \brief Constructor
         */
        ChppLosFeetAreaTask ( ChppLosCentipede& inCentipede, ChppLosLink& inLink );
        /**
        \brief Set the area of translation brake inside the authorized configurations region boudaries
         */
        void setTranslationMargins ( double inDi, double inDs, double inXi );
        /**
        \brief Set the area of rotation brake inside the authorized configurations region boudaries
         */
        void setRotationMargins ( double inDi, double inDs, double inXi );
        /**
        \brief Inherited. Return false
         */
        bool isEqualityTask() const {return false;};
        /**
        \brief Inherited.
         */
        void computeDifferentialSystem();
        /**
        \brief Inherited.
         */
        const vectorN& currentValue();

    private:
        
        ChppLosLink* attLink;
        double attStepXi,attStepDi,attStepDs;
        double attThetaXi,attThetaDi,attThetaDs;
};

#endif

