/*
  Copyright 2009 CNRS-LAAS

  Author: Oussama Kanoun
*/
#ifndef HPP_LOS_GAZE_TASK_H
#define HPP_LOS_GAZE_TASK_H

#include "hpplocalstepper/tasks/hppLosPointingTask.hh"
class ChppLosRobotLink;
/**
A task to align a vector in a robot's gaze frame on a point in world frame
\ingroup tasks
 */
class ChppLosGazeTask: public ChppLosPointingTask
{
    public:

        /**
        \brief Constructor
         */
        ChppLosGazeTask(ChppLosCentipede& inCentipede, ChppLosRobotLink& inRobotLink, const vector3d& inWorlTarget );

        /**
        \brief Set the origin of the pointing vector in joint's local frame (illelgal operation for gaze constraint).
         */
        void  localOrigin ( const vector3d& inPoint ) ;
        /**
        \brief Get the origin of the pointing vector.
         */
        const vector3d& localOrigin();
        /**
        \brief Set the pointing vector in joint's local frame (illelgal operation for gaze constraint).
         */
        void  localVector ( const vector3d& inPoint );
        /**
        \brief Set the pointing vector in joint's local frame
         */
        const vector3d& localVector();
};

#endif
